~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/tools/time/udelay_test.sh

Version: ~ [ linux-6.6-rc4 ] ~ [ linux-6.5.5 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.55 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.133 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.197 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.257 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.295 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.326 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.9 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

  1 #!/bin/bash
  2 
  3 # udelay() test script
  4 #
  5 # Test is executed by writing and reading to /sys/kernel/debug/udelay_test
  6 # and exercises a variety of delays to ensure that udelay() is delaying
  7 # at least as long as requested (as compared to ktime).
  8 #
  9 # Copyright (C) 2014 Google, Inc.
 10 #
 11 # This software is licensed under the terms of the GNU General Public
 12 # License version 2, as published by the Free Software Foundation, and
 13 # may be copied, distributed, and modified under those terms.
 14 #
 15 # This program is distributed in the hope that it will be useful,
 16 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 17 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 18 # GNU General Public License for more details.
 19 
 20 MODULE_NAME=udelay_test
 21 UDELAY_PATH=/sys/kernel/debug/udelay_test
 22 
 23 setup()
 24 {
 25         /sbin/modprobe -q $MODULE_NAME
 26         tmp_file=`mktemp`
 27 }
 28 
 29 test_one()
 30 {
 31         delay=$1
 32         echo $delay > $UDELAY_PATH
 33         tee -a $tmp_file < $UDELAY_PATH
 34 }
 35 
 36 cleanup()
 37 {
 38         if [ -f $tmp_file ]; then
 39                 rm $tmp_file
 40         fi
 41         /sbin/modprobe -q -r $MODULE_NAME
 42 }
 43 
 44 trap cleanup EXIT
 45 setup
 46 
 47 # Delay for a variety of times.
 48 # 1..200, 200..500 (by 10), 500..2000 (by 100)
 49 for (( delay = 1; delay < 200; delay += 1 )); do
 50         test_one $delay
 51 done
 52 for (( delay = 200; delay < 500; delay += 10 )); do
 53         test_one $delay
 54 done
 55 for (( delay = 500; delay <= 2000; delay += 100 )); do
 56         test_one $delay
 57 done
 58 
 59 # Search for failures
 60 count=`grep -c FAIL $tmp_file`
 61 if [ $? -eq "0" ]; then
 62         echo "ERROR: $count delays failed to delay long enough"
 63         retcode=1
 64 fi
 65 
 66 exit $retcode

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

osdn.jp